precision highp float;


varying highp vec2 st;
uniform sampler2D inputImageTexture;
uniform vec2 size;
//uniform float grain;
//uniform float seed;

mat4 bayerIndex = mat4(
vec4(00.0/16.0, 12.0/16.0, 03.0/16.0, 15.0/16.0),
vec4(08.0/16.0, 04.0/16.0, 11.0/16.0, 07.0/16.0),
vec4(02.0/16.0, 14.0/16.0, 01.0/16.0, 13.0/16.0),
vec4(10.0/16.0, 06.0/16.0, 09.0/16.0, 05.0/16.0));

void main()
{
    // sample the texture
    vec4 col = texture2D(inputImageTexture, st);

    // gamma correction
    col = vec4(pow(col.rgb, vec3(2.2)) - 0.004, col.a);

    vec2 uv = st * size;
    // find bayer matrix entry based on fragment position
    float bayerValue = bayerIndex[int(mod(uv.x, 4.0))][int(mod(uv.y, 4.0))];
    // output
    gl_FragColor = vec4(
    step(bayerValue, col.r),
    step(bayerValue, col.g),
    step(bayerValue, col.b),
    col.a);
}