precision highp float;
#define TWO_PI 6.28318530718
#define Y 0.1

varying vec2 st;
uniform sampler2D inputImageTexture;
uniform float exposure;

float rgb2gray(vec3 rgb){
    return dot(vec3(0.299, 0.587, 0.114), rgb);
}


void main() {
    vec4 color = texture2D(inputImageTexture, st);
    float gray = rgb2gray(color.rgb);
    if(gray > 0.5){
        gl_FragColor = vec4((color.rgb - vec3(0.5)) * vec3(1.0 + exposure) + vec3(0.5), color.a);
    }else{
        gl_FragColor = color;
    }
}