precision highp float;

varying vec2 st;
uniform sampler2D inputImageTexture;
uniform sampler2D blurImageTexture;
uniform vec2 size;
uniform float strength;

void main() {
    vec4 col = texture2D(inputImageTexture, st);
    vec4 blur = texture2D(blurImageTexture, st);
    vec3 diff = col.rgb - blur.rgb;
    vec4 result = vec4(blur.rgb + diff * strength, col.a);
    result.r = texture2D(blurImageTexture, st - vec2(1.5 / size.x, 0.0)).r;
    result.b = texture2D(blurImageTexture, st + vec2(1.5 / size.x, 0.0)).b;
    gl_FragColor =  result;
}
