precision highp float;
#define TWO_PI 6.28318530718
#define Y 0.1

varying vec2 st;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2;
uniform vec2 size;
uniform float strength;
uniform float whiten;


void main() {
    vec4 mask = texture2D(inputImageTexture2, st);
    vec4 color0 = texture2D(inputImageTexture1, st);
    if(mask.a > 0.0){
        vec3 result = vec3(0.);
        vec4 color = vec4(0.);
        vec3 weight = vec3(0.);
        vec3 weight_sum = vec3(0.);
        float radius = size.x * 0.05;
        for(float r = radius / 4.0; r <= radius; r += radius / 4.0){
            for (float theta = 0.; theta < TWO_PI; theta += TWO_PI / 12.){
                color = texture2D(inputImageTexture1, st + r * vec2(cos(theta), sin(theta)) / size);
                weight = exp(-pow(vec3(color.g - color0.g), vec3(2.)) / 0.04);
                weight_sum += weight;
                result += weight * color.rgb;
            }
        }
        result = result / weight_sum;
//        gl_FragColor = vec4(mix(color0.rgb, 2.0 * result * color0.rgb / (result + color0.rgb + 0.0001), strength), color0.a);
        result = mix(color0.rgb, result, strength);
        //        result = mix(color0.rgb, 2.0 * result * color0.rgb / (result + color0.rgb + 0.0001), strength);
        gl_FragColor = vec4(pow(result, vec3(1. / whiten)), color0.a);
//        gl_FragColor = vec4(result, color.a);
    }else{
        gl_FragColor = color0;
    }
}